define("dojo/store/util/QueryResults", ["dojo"], function(dojo) {
dojo.getObject("store.util", true, dojo);

dojo.store.util.QueryResults = function(results){
	//	summary:
	//		This wraps a query results with the appropriate methods
	// if it is a promise it may be frozen
	if(results.then){
		results = dojo.delegate(results);
	}
	function addIterativeMethod(method){
		if(!results[method]){
			results[method] = function(){
				var args = arguments;
				return dojo.when(results, function(results){
					Array.prototype.unshift.call(args, results);
					return dojo[method].apply(dojo, args);
				});
			}
		}
	}
	addIterativeMethod("forEach");
	addIterativeMethod("filter");
	addIterativeMethod("map");
	if(!results.total){
		results.total = dojo.when(results, function(results){ 
			return results.length
		});
	}
	return results;
};

return dojo.store.util.QueryResults;
});